#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "watdefs.h"
#include "afuncs.h"

#define DEG2RAD 1.74532925199432957692369E-2
//#define RAD2DEG 57.29577951308232087679815

static void
print_usage(void)
{
  static char progname[]="EQ2GA";
  static char verid[]="v.1.0";

  printf("%s %s - Usage:\n", progname, verid);
  printf("   eq2ga  RA Dec [Flag]\n");
  printf("   Input values are in fractional degrees.\n");
  printf("   Optional Flag > 0 ==> l,b -> RA,Dec.\n\n");
  exit(0);
}

/* The entry point for the program */

int
main(int argc, char *argv[])
{
  double di1rad, di2rad, di1deg, di2deg, do1rad, do2rad;

  int iflag=0;
  int args=1;

  if (argc < 3)
    print_usage();

    di1deg = atof(argv[args++]);
    di2deg = atof(argv[args++]);
    di1rad = di1deg * DEG2RAD;
    di2rad = di2deg * DEG2RAD;
    if (argc == 4) { iflag = atoi(argv[args]); }
//printf("%lf %lf %d\n",di1,di2,iflag);
  if (iflag > 0)
  {
    galactic_to_ra_dec(di2rad, di1rad, &do1rad, &do2rad);
  } else {
    ra_dec_to_galactic(di1rad, di2rad, &do2rad, &do1rad);

double l_deg, b_deg;
l_deg = ra_dec2Gl(di1deg, di2deg);
b_deg = ra_dec2Gb(di1deg, di2deg);
printf("l=%12.7lf b=%12.7lf\n", l_deg, b_deg);
  }

  printf("%12.7lf %12.7lf\n", do1rad/DEG2RAD, do2rad/DEG2RAD);

  return 0;
}
