/*
  double deg_dec.c

  Purpose:

   Decode a declination string formatted as "+/-dd mm ss.s" or "+/-dd:mm:ss.s"
   into a fractional double precision value.


   LN@IASF-CNR, November 2004                   ( Last change: 12/02/2007 )
*/

#include <stdio.h>

double deg_dec(char *dec_str)
{
  unsigned int deg, dem;
  float defs;
  double de;
  char sign[2];

//  sscanf(dec_str,"%1s%2d%1s%2d%1s%f",&sign, &deg, &div, &dem, &div, &defs);
  *sign=dec_str[0];
  if (*sign != '+' && *sign != '-') {
    sscanf(dec_str,"%2d", &deg);
    dec_str += 3;
  } else {
    sscanf(dec_str,"%1s%2d",sign, &deg);
    dec_str += 4;
  }
  sscanf(dec_str,"%2d", &dem);
  dec_str += 3;
  sscanf(dec_str,"%f", &defs);
  dec_str -= 7;
  de  = deg + dem/60. + defs/3.6e3;
  if (sign[0] == '-') de *= -1;
//  printf("dec=%f\n",de);
  return (de);
}
