/*
  double deg_ra.c

  Purpose:

   Decode a right ascension string formatted as "hh mm ss.s" or "hh:mm:ss.s"
   into a fractional double precision value.


   LN@IASF-CNR, November 2004                   ( Last change: 18/11/2004 )
*/

#include <stdio.h>

double deg_ra(char *ra_str)
{
  unsigned int rah,ram;
  float rafs;
  double ra;
//  static char str_ra[20];

  sscanf(ra_str,"%2d", &rah);
  ra_str += 3;
  sscanf(ra_str,"%2d", &ram);
  ra_str += 3;
  sscanf(ra_str,"%f", &rafs);
  ra_str -= 6;
  ra  = (rah + ram/60. + rafs/3.6e3) * 15.;
  if (ra < 0.) ra *= -1;
//  printf("ra=%f\n",ra);
  return (ra);
}
