/*
   my_db.h

  Purpose:

   Include file for "my_db.c".

   LN@IASF-CNR, January 2003                   ( Last change: 07/08/2009 )
*/

//#include "includes/common.h"
//#include "settings/maxconn.h"
//#include "settings/const.h"

#ifndef MY_DB_H
#define MY_DB_H

#undef __BEGIN_DECLS
#undef __END_DECLS
#ifdef __cplusplus
# define __BEGIN_DECLS extern "C" {
# define __END_DECLS }
#else
# define __BEGIN_DECLS /* empty */
# define __END_DECLS /* empty */
#endif

#include <mysql.h>  /* header of the database client API library */

#define MYSQL_SOCK NULL

#define PASSWORD "12345678"
#define DEFAULT_TIMEOUT "5"   /* Timeout in seconds: must be char */

__BEGIN_DECLS

int db_init(int ID);
int db_connect(int ID, char *host, const char *username, const char *password, char *db);
const char * db_error(int ID);
int db_return_row(int ID);
int db_query(int ID, const char *query);
unsigned int db_num_fields(int ID);
unsigned int db_num_rows(int ID);
char *db_fieldname(int ID, int ord);
enum enum_field_types db_fieldtype(int ID, int ord);
unsigned int db_fieldlength(int ID, int ord);
char *db_data(int ID, unsigned int row, unsigned int field);
short db_unsigned(int ID, int ord);
void db_free_result(int ID);
void db_close(int ID);

__END_DECLS

#endif
