/*
  praws_BSC.c

  Purpose:

   Print in a human readable format the selected rows from the RossCats.BSC
   catalogue.

   LN@IASF-CNR, July 2003                   ( Last change: 16/04/2004 )

*/

#include <stdio.h>
#include <string.h>
#include "my_db.h"

//char *db_data(int ID, unsigned int row, unsigned int field);
//unsigned int db_num_rows(int ID);

extern char *enc_str_ra(char *racs_str);
extern char *enc_str_dec(char *deccs_str);

/* Reference epoch to subtract to meanEpoch */
#define REF_EPOCH 1950.0

int praws_BSC()
{
  unsigned long j;
  unsigned short HR;
  short MultCnt;
  float  GLON, GLAT, Vmag, BmV, UmB, RmI, RaPM, DecPM, Parallax;
  char   Name[11], IRflag[2], Multiple[2], ADScomp[3], VarID[10],
         RA[11], DE[10], SpType[21];

/* Print header */
    printf(" HR      Name     IRflag  Multiple  ADScomp    VarID       RA     "
           "     DEC      GLON    GLAT    Vmag   BmV    UmB    RmI   "
           "       SpType          RaPM   DecPM   Parallax  MultCnt\n"
           "----  ----------  ------  --------  -------  ---------  ----------"
           "  ---------  ------  ------  -----  -----  -----  -----  "
           "--------------------  ------  ------  --------  -------\n");
/* Print the data */
   for (j = 0; j < db_num_rows(0); j++)
   {
      sscanf(db_data(0, j, 0),"%hu",&HR);
      strcpy(Name , db_data(0, j, 1));
      if ( ! strlen(Name) ) strcpy(Name,"*");
      strcpy(IRflag , db_data(0, j, 2));
      if ( ! strlen(IRflag) ) strcpy(IRflag,"*");
      strcpy(Multiple , db_data(0, j, 3));
      if ( ! strlen(Multiple) ) strcpy(Multiple,"*");
      strcpy(ADScomp , db_data(0, j, 4));
      if ( ! strlen(ADScomp) ) strcpy(ADScomp,"*");
      strcpy(VarID , db_data(0, j, 5));
      if ( ! strlen(VarID) ) strcpy(VarID,"*");
      strcpy(RA , db_data(0, j, 6));
      if ( ! strlen(RA) )
      {
        printf("Empty RA field. HR = %d \n",HR);
        return 1;
      }
/* Replace blanks with ":" */
      RA[2] = ':';
      RA[5] = ':';

      strcpy(DE , db_data(0, j, 7));
      if ( ! strlen(DE) )
      {
        printf("Empty DEC field. HR = %d \n",HR);
        return 1;
      }
/* Replace blanks with ":" */
      DE[3] = ':';
      DE[6] = ':';
/* Skip fields 8, 9 as they are RA, Dec in fractional degrees */
      sscanf(db_data(0, j,10),"%f",&GLON);
      sscanf(db_data(0, j,11),"%f",&GLAT);
      sscanf(db_data(0, j,12),"%f",&Vmag);
      sscanf(db_data(0, j,13),"%f",&BmV);
      sscanf(db_data(0, j,15),"%f",&UmB);
      sscanf(db_data(0, j,17),"%f",&RmI);
      strcpy(SpType , db_data(0, j,19));
      if ( ! strlen(SpType) ) strcpy(SpType,"*");
      sscanf(db_data(0, j,21),"%f",&RaPM);
      sscanf(db_data(0, j,22),"%f",&DecPM);
      sscanf(db_data(0, j,24),"%f",&Parallax);
      sscanf(db_data(0, j,28),"%hu",&MultCnt);

      printf("%4d  %10s    %1s        %1s        %2s     %9s  %10s  %9s  %6.2f  %6.2f  %5.2f  %5.2f  %5.2f  %5.2f  %20s  %6.3f  %6.3f   %6.3f     %2d\n",
      HR,Name,IRflag,Multiple,ADScomp,VarID,RA,DE,GLON,GLAT,Vmag,BmV,UmB,RmI,SpType,RaPM,DecPM,Parallax,MultCnt);
/*
      for(i = 0; i < db_num_fields(0); i++)
        printf("%s\t", db_data(0, j, i));
      printf("\n");
*/
   }
   return 0;
}
