/*
   Wrapper for Fortran calls.

   HTM ID and trixel name at a given depth and coordinates.

   Return 0 if OK.
*/
using namespace std;

#include <cstdlib>
#include "SpatialVector.h"
#include "SpatialInterface.h"

extern "C" {

int htmid_pp_(int *dpt, float *ra, float *dec, int *id, char *name, int *name_len)
{

  size_t depth = *dpt;

  htmInterface *htm = NULL;

  try {

    htm = new htmInterface(depth);
    *id = htm->lookupID(*ra,*dec);
    strcpy(name,htm->lookupName((float64) *ra, (float64) *dec) );

  } catch (SpatialException x) {
    cout << x.what() << endl;
  }

  delete htm;

// Null filling
   for (int j=strlen(name); j<*name_len; j++)
       name[j]='\0';
   return 0;
}

}
