@mcs_usrlib   ; User contributed Functions and Pro

PRO mcs_simpleqry
;+
; NAME:
;       MCS_SIMPLEQRY
;
; PURPOSE:
;   MCS demonstration program using the routines in the "mcs_usrlib" library.
;
;   Use the 'simpleBSC' catalogue in the mpe2014 DB.
;
;   Show usage of DBExec_Qry, DBExec_TabQry and DBExec_ShowQry, DBTabFLT.
;
; CATEGORY:
;   MCS demonstration program using the mcs_usrlib library.
;
; CALLING SEQUENCE:
;   mcs_simpleqry
;
; INPUT PARAMETERS:
;   None.
;
; MODIFICATION HISTORY:
;   Written by L. Nicastro @ INAF-OAS, July 2006.
;  24/05/2018: LN, changed for the IMPRS DB course.
;-

; This is the common section for the "mcs_usrlib"
COMMON DBinfo,  c_host, c_user, c_password, c_dbname, c_query
COMMON TABinfo, mcs_types, is_rowstru, n_fields, n_rows, f_name, $
                f_atype, f_itype, tab_stru

; Here we use the common block parameters instead of passing them
  c_user  = 'mpeusr'  &  c_password = 'mpe2018pass'  &  c_dbname = 'mpe2018db'
  c_query = 'SELECT * FROM simpleBSC where V > 0 and V < 2.5'


;stat=DBExec_Qry(nrec=nr)
;IF (stat NE 0) THEN RETURN
;print,'Returned n_rows=',nr

; All in one func.: open connection, execute query, store the result, close
  status = DBExec_TabQry(c_dbname,c_user,c_password,c_query,/debug)

  IF (status NE 0) THEN RETURN  ; Error?

; The result set is stored in a structure 
  PRINT, 'Info on the returned structure (note the _NULL fields):'
  HELP, /STRU, tab_stru

; As before, but now we an array of structures. Note that the DB connection is closed!
  status = DBExec_ShowQry(/use_saved_info) ; return 0 if OK

  IF (status NE 0) THEN RETURN  ; Error?

; As before, but now we ask for a structure of arrays.
  status = DBExec_ShowQry(/use_saved_info,/arr_stru) ; return 0 if OK

  PRINT, 'Info on the returned structure:'
  HELP, /STRU, tab_stru

; Now we select a subset of the columns and save them into a float matrix

  c_query = 'select radeg, decdeg, B FROM simpleBSC where b!=-9.99 and B<3.0'
  status = DBExec_Qry(c_dbname,c_user,c_password,c_query)
  d = DBTabFLT()
  help, d
  print, d

  DBclose
END
