pro myquery1
;+
; Simple query using the MCS to IDL wrapper. mcs_usrlib.pro is NOT used.
;-

; MCS-IDL recognised data types
  mcs_types = [Types_TINY(), Types_SMALL(), Types_MEDIUM(), Types_INT(), $
               Types_BIGINT(), Types_FLOAT(), Types_DOUBLE(), Types_STRING(), $
               Types_TIME(), Types_TINY_BLOB(), Types_BLOB(), Types_POINTER(), $
               20, 21]
  idl_types = [ $
    ['INTARR','LONARR','LON64ARR','UINTARR','ULONARR','ULON64ARR', $
     'FLTARR','DBLARR','STRARR','BYTARR','PTRARR'], $
    ['FIX(0)','LONG(0)','LONG64(0)','UINT(0)','ULONG(0)','ULONG64(0)', $
     'FLOAT(0)','DOUBLE(0)','STRING("")','BYTE(0)','PTR_NEW(0)'] $
  ]


  for j=0, n_elements(mcs_types)-1 do $
    print, 'mcs_type=', mcs_types[j], '  idl_type=', idl_types[j]

; Define a connection object
  dbc = new_DBConn(ifd_null())
; Connect to DB
  DBConn_connect, dbc, 'mpeusr', 'mpe2018pass', 'mpe2018db', 'localhost'
; Define a query object
  dbq = new_Query(ifd_null(), dbc, 0)

; The query to execute
  qry = 'select * from BSC limit 1'

; Execute a simple query
  Query_query, dbq, qry, 1

; The number of rows returned
  n_rows = RecordSet_nRows(dbq)
; The number of fields returned
  n_fields = RecordSet_nFields(dbq)

  print, 'n_rows=', n_rows
  print, 'n_fields=', n_fields

; The object with the fields metadata
  v = RecordSet_metarec(dbq)

; Print the fields info
print, "Field_name, Field_type, Is_unsigned"
print, "-----------------------------------"

  FOR j=0, n_fields-1 DO BEGIN
    d = Record_field(v, j)
    f_name = Data_name(d)
    t = Data_type(d)
    is_uns = Data_isUnsigned(d)
print, f_name, t, is_uns
  ENDFOR

; Destroy objects
  del_Query, dbq
  del_DBConn, dbc
  dbq = ifd_null()
  dbc = ifd_null()
END
