#!/usr/bin/env python

#+
# Simple catalogue query using DIF facilities.
#-

import MySQLdb

cat = "ucac2_initial"  # The catalogue to query
c_ra = 10.1  # deg
c_de = 20.2  # deg
r = 30.0     # arcmin

lim = 50     # max Nr. of rows to return

db = MySQLdb.connect(host="127.0.0.1",      # your host, usually localhost, but on some systems/installations it has to be 127.0.0.1
                     user="mpeusr",         # your username
                     passwd="mpe2018pass",  # your password
                     db="mpe2018db")        # name of the data base

# you must create a Cursor object: it will let you execute all the queries you need
cur = db.cursor()

# use any SQL you like
qry = "SELECT ROUND(RAmas/3.6e6, 4) as radeg, ROUND(DECmas/3.6e6, 4) as dedeg, RAPMdm*10 as RApm, DECPMdm*10 as DECpm, Amm*1000 as Amag, sphedist(radeg,dedeg, %s,%s) as sep FROM %s_htm_6 WHERE dif_circle(%s,%s,%s) limit %s" % (c_ra,c_de, cat, c_ra,c_de,r, lim)

cur.execute(qry)

# get the number of rows in the resultset
numrows = int(cur.rowcount)
print "Returned number of rows: ", numrows

# get the number of fields and their names
num_fields = len(cur.description)
field_names = [i[0] for i in cur.description]
print field_names

# get and display one row at a time.
for x in range(0, numrows):
    row = cur.fetchone()
    print row[0], row[1], row[2],  row[3], row[4], row[5], row[6]

#for row in cur.fetchall():
#    print row[0], row[1], row[2],  row[3], row[4]
#
db.close()
