#!/usr/bin/env python

#+
# Simple catalogue query.
#-

import MySQLdb

# definitions
cat = "ucac2_initial"  # The catalogue to query
c_ra = 10.1  # deg
c_de = 20.2  # deg
r = 30.0     # arcmin

lim = 50     # max Nr. of rows to return

# connect to the DB
db = MySQLdb.connect(host="127.0.0.1",      # your host, usually localhost, but on some systems/installations it has to be 127.0.0.1
                     user="mpeusr",         # your username
                     passwd="mpe2018pass",  # your password
                     db="mpe2018db")        # name of the data base

# you must create a Cursor object: it will let you execute all the queries you need
cur = db.cursor()

# use all the SQL you like: note the exponential notation for the normalization factors!
qry = "SELECT ROUND(RAmas/3.6e6, 4) as radeg, ROUND(DECmas/3.6e6, 4) as dedeg, RAPMdm/1e1 as RApm, DECPMdm/1e1 as DECpm, Amm/1e3 as Amag, stat1, stat2 FROM %s limit %s" % (cat, lim)

# execute the query
cur.execute(qry)

# get the number of rows in the resultset
numrows = int(cur.rowcount)
print "Returned number of rows: ", numrows

# get the number of fields and their names
num_fields = len(cur.description)
field_names = [i[0] for i in cur.description]
print field_names

# get and display one row at a time
for x in range(0, numrows):
    row = cur.fetchone()
    print row
    #print row[0], row[1], row[2],  row[3], row[4], row[5], row[6]

#for row in cur.fetchall():
#    print row[0], row[1], row[2],  row[3], row[4]
#
db.close()
