#!/usr/bin/env python

#+
# Simple query from a catalogue using SID.
#-

from contextlib import closing
import MySQLdb

usr = "mpeusr"        # your username
pwd = "mpe2018pass"   # your password
dbname = "mpe2018db"  # name of the database
cat = "ascc25" # catalogue to query
c_ra = 30.     # RA in deg
c_de = -20.    # Dec in deg
r = 30.0       # tadius in arcmin

dbcat = "%s.%s" % (dbname, cat) # db+catalogue to query

lim = 'LIMIT 50'     # max Nr. of rows to return

try:
  db = MySQLdb.connect(host="127.0.0.1",  # usually localhost, but on some systems/installations it has to be 127.0.0.1
                     user=usr,
                     passwd=pwd,
                     db=dbname)

  with closing(db.cursor()) as cur:
# the Cursor object: it will let you execute all the queries you need.
    cur = db.cursor()

# note that we are invoking a stored procedure, so the result is not immediately available via "cursor"
  #cur.execute(qry)

    res = cur.callproc("SID.SelectCircleHTM", ('', '*', dbcat, 'htm6',  6, 'RAmas/3.6e6', 'DECmas/3.6e6', c_ra, c_de, r, lim))

# first returned string is the call to the procedure that creates the temporary region IDs table SID.sid
    row = cur.fetchone()
    print row[0]

# the second string reports the actual join query to select objects in the region
    cur.nextset()
    row = cur.fetchone()
    print row[0]

# now we move to the returned data set (empty if an output table was given)
    cur.nextset()

# get the number of rows in the resultset
    numrows = int(cur.rowcount)
    print "\nReturned number of rows: ", numrows

# get the number of fields and their names
    num_fields = len(cur.description)
    field_names = [f[0] for f in cur.description]
    print "Field names:\n", field_names, "\n"

# get and display one row at a time
    for i in range(0, numrows):
        row = cur.fetchone()
        v = [row[j] for j in range(0, num_fields)]
        print v

  #for row in cur.fetchall():
  #    print row
  #

  db.close()

except MySQLdb.Error, e:
    print "MySQL Error %d:  %s" % ( e.args[0], e.args[1] )
    sys.exit(1)
